#!/usr/bin/perl -w
#
# Taken from ftp://ftp.ora.com/published/oreilly/nutshell/web-client/ 
# 
# Modified by: Patrick Bulteel
# Date: 02/16/2004 - (I love you hunny! It's my anniversary!)
#
# Modified so that it uses perl more extensively instead of running lynx.
# Also modified so that it uses a wildcard for Busy and Idle servers instead
# of having to hit the server twice, we can do it all in one swell swoop.
#

use strict;
use LWP::UserAgent;
use HTTP::Request;
use HTTP::Response;

my $ua = new LWP::UserAgent;
# I added this to the original O'reilly code...
my $fullurl = "http://" . $ARGV[0] . "/server-status?auto";

# I changed this from the original O'reilly code...
my $request = new HTTP::Request('GET', $fullurl);
my $response = $ua->request($request);
if ($response->is_success) {
    # I grabbed this from the original unix_apachestats.pl
     $response->content =~ /Total Accesses: (.*)/; 
    print "apache_total_hits:".$1." "; 
    $response->content =~ /Total kBytes: (.*)/; 
    print "apache_total_kbytes:".$1." ";
    # I wildcarded the Busy and Idle stats... =)
    $response->content =~ /Busy.*: (.*)/;
    print "apache_busy_workers:".$1." ";
    $response->content =~ /Idle.*: (.*)/;
    print "apache_idle_workers:".$1;
} else {
     print $response->error_as_HTML;
}
